#include <cstdlib>
#include <iostream>

using namespace std;

class Phone {
    protected: // Allows subclasses to access the data members of the superclass
        string color;
        int number;
    public:
        Phone(string c, int no): color(c), number(no) { }
        //virtual void displayData() {
        void displayData() {
            cout << ">> Phone <<" << endl;
            cout << "Color: " << color << " Phone number: " << number << endl;
        }
};

class CablePhone : public Phone {
    private:
        int cablelength;
    public:
        CablePhone(string c, int no, int cl): Phone(c, no), cablelength(cl) { }
        void displayData() {
            cout << ">>CablePhone<<" << endl;
            cout << "Color: " << color << " Phone number: " << number << endl;
            cout << "Cable length: " << cablelength << " meters" << endl;
            }
};

class MobilePhone : public Phone {
    private:
        string network;
    public:
        MobilePhone(string c, int no, string n): Phone(c, no), network(n) { }
        void displayData() {
            cout << ">>MobilePhone<<" << endl;
            cout << "Color: " << color << " Phone number: " << number << endl;
            cout << "Network: " << network << endl;
        }
};

int main()
{
    Phone *p = new Phone("Black", 49172123456);
    CablePhone *cp = new CablePhone("Blue", 4999123456, 2);
    MobilePhone *mp = new MobilePhone("White", 491994433222211, "BestNet");
    p-> displayData();
    p = cp;
    p-> displayData();
    p = mp;
    p-> displayData();

    //without the keyword virtual only the function displayData of the class Phone is called
    //with the keyword virtual the function displayData is called by the corresponding class

    system("pause");
    return 0;
}
