#include <iostream>
#include <cstdlib>

using namespace std;

class Customer
{
	protected:
        float Payment;
	public:
		virtual void Pay(float Payment)
		{
			this-> Payment = Payment;
			cout << "Customer:" << this-> Payment << endl;
		};
};

class NewCustomer : public Customer
{
	public:
		void Pay(float Payment)
		{
			this-> Payment= Payment*0.9;
			cout << "NewCustomer:" << this->Payment << endl;
		}
};

class RegularCustomer : public Customer
{
	public:
		void Pay(float Payment)
		{
			this-> Payment=Payment*0.8;
			cout << "RegularCustomer:" << this->Payment << endl;
		}
};

//this -> Takes the property from the own/base class
//without this -> Takes the input parameter

void CPayment(Customer &Person, float Sum)
{
	Person.Pay(Sum);
}

int main()
{
	Customer Hansen, Meier;
	NewCustomer Mueller;
	RegularCustomer Gaston, Baumann;

	CPayment(Hansen, 50);
	CPayment(Meier, 70);

	CPayment(Mueller, 100);

	CPayment(Gaston, 200);
	CPayment(Baumann, 300);

	system("pause");
	return 0;
}
