#include <iostream>
#include <cstdlib>

using namespace std;

class Animal {
protected:
    string name;
public:
    Animal(string n) : name(n) {};
    string get_name() { return name; }
    virtual void makeSound() = 0;
};


class Cow : public Animal {
public:
    Cow(string n) : Animal(n) {};
    void makeSound()
    {
        cout << "Moo" << endl;
    }
};

class Dog : public Animal {
public:
    Dog(string n) : Animal(n) {};
    void makeSound()
    {
        cout << "Woof" << endl;
    }
};

int main()
{
    Cow k("Betsy");
    Dog h("Bello");

    cout << k.get_name() << " makes ";
    k.makeSound();
    cout << h.get_name() << " makes ";
    h.makeSound();

    system("pause");
    return 0;
}
